/*
 * Copyright (C) 2021. Huawei Technologies Co., Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 and
 * only version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 */

#ifndef LIBSTORAGE_INTERNAL_DEBUG_H
#define LIBSTORAGE_INTERNAL_DEBUG_H
#include "spdk/stdinc.h"

struct spdk_debug_subsystem {
	const char *name;
	void (*output)(FILE *file);
	TAILQ_ENTRY(spdk_debug_subsystem) tailq;
};

void spdk_add_debug_subsystem(struct spdk_debug_subsystem *subsystem);

/**
 * \brief Register a new subsystem
 */
#define SPDK_DEBUG_REGISTER(_name, _output) \
	struct spdk_debug_subsystem __spdk_debug_subsystem_ ## _name = \
	{   \
		.name = #_name,                             \
		.output = _output,                          \
	};  \
	__attribute__((constructor)) static void _name ## _debug_register(void) \
	{   \
		spdk_add_debug_subsystem(&__spdk_debug_subsystem_ ## _name);    \
	}

void spdk_output_debug_info(void);

#endif
